<?php
//Проверка на авторизацию
User::a()->noLogin();
$Forum = new Forum;
$page = 1;
/*Подключаемые модули*/
$url_param = Module::a()->url;
		if(isset($url_param[1])){	
			switch($url_param[1]){
					case 'Add':
						if(User::a()->isAdmin === false){
							header("Location:/Forum/");
							die();
							}

					if(isset($_POST['name'])){
							$error=array();	
							$name = htmlspecialchars(strip_tags(trim($_POST['name'])));
							$admin = htmlspecialchars(strip_tags(trim($_POST['status'])));
							$new = htmlspecialchars(strip_tags(trim($_POST['new'])));
							if(empty($name) || mb_strlen($name,'UTF-8')<3)$error[] = "Название раздела состоять не менее,чем из 3-х символов!";	
							if(mb_strlen($name,'UTF-8')>30)$error[] = "Ник должен состоять не более,чем из 30-ти символов!";
					
					if(count($error)<1){	
						$Forum->addForum($name,$admin,$new);
						$_SESSION['info'] = "Раздел добавлен";
						header("Location:/Forum/");
						die();					
						}
					}
					Template::a()->setTitle('Создание раздела');
					Template::a()->set('Forum',$Forum);
					Template::a()->set('error',$error);
					Template::a()->display('forum/addForum');		
					break;

					case 'ShowTopics':
					if(!isset($url_param[2]) || !is_numeric($url_param[2])){
							header("Location:/Forum/");
							die();
							}

					if(isset($_GET['page']) && !isset($url_param[4]))$page = abs(intval($_GET['page']));
					else $page = 1;

					$data = $Forum->getTopics($url_param[2],$page);
					if($data===false || count($data['topics'])<1 && $page>1){
							header("Location:/Forum/");
							die();
							}	

							if(isset($url_param[3])){	
									switch($url_param[3]){
									case 'NewTopic':
													if(User::a()->user['status']<$data['forum']['newTop']){
														header("Location:/Forum/");
														die();
														}

													if(User::a()->isBan === true){
														header("Location:/Forum/");
														die();
														}
														
														

									if(isset($_POST['name'])){
										$error=array();	
										$name = htmlspecialchars(strip_tags(trim($_POST['name'])));
										$text = htmlspecialchars(strip_tags(trim($_POST['text'])));
										if(empty($name) || mb_strlen($name,'UTF-8')<3)$error[] = "Короткое название!";	
										if(mb_strlen($name,'UTF-8')>70)$error[] = "Название должно состоять не более,чем из 70-ти символов!";
										if(empty($text) || mb_strlen($text,'UTF-8')<5)$error[] = "Короткое сообщение!";	
										if(mb_strlen($text,'UTF-8')>2000)$error[] = "Слишком длинное сообщение!Максимально разрешено использовать не более 2000 символов";
												
												if(count($error)<1){	
													$result = $Forum->addTopic($data['forum']['id'],$name,User::a()->user['id'],$text);
													$_SESSION['info'] = "Топик создан";
													header("Location:/Forum/ShowTopics/".$data['forum']['id']."/Topic/".$result);
													die();					
													}
												}
										Template::a()->setTitle('Создание топика');
										Template::a()->set('Forum',$Forum);
										Template::a()->set('error',$error);
										Template::a()->display('forum/addTopic');		
										break;
										
										case 'Topic':
													if(!isset($url_param[4])){
														header("Location:/Forum/");
														die();
														}

										if(isset($_GET['page']))$page = abs(intval($_GET['page']));
										else $page = 1;

										$data = $Forum->getMessages($url_param[4],$page);	
										if($data===false && count($data['mess'])<1 && $page>1){
												/**/
												die();
												}
										/*Закрытие топиков*/
										if(isset($_GET['closed'])){
											if(User::a()->isModer===false){
												header("Location:/Forum/");
												die();												
											}
										
										$Forum->closed($url_param[4]);
										header("Location:/Forum/ShowTopics/".$data['topic']['forum']."/Topic/".$data['topic']['id']."/");
										}

										/*Удаление топиков*/
										if(isset($_GET['delete'])){
											if(User::a()->isSupport===false){
												header("Location:/Forum/");
												die();												
											}
										
										$Forum->delete($url_param[4]);
										header("Location:/Forum/ShowTopics/".$data['topic']['forum']."/");
										}

										/*Удаление сообщений*/
										if(isset($_GET['delMessage'])){
											if(User::a()->isModer===false){
												header("Location:/Forum/");
												die();												
											}
										
										$Forum->delMessage($_GET['delMessage']);
										header("Location:/Forum/ShowTopics/".$data['topic']['forum']."/Topic/".$data['topic']['id']."/");
										}
	
										if(isset($_POST['text'])){
										$error=array();	
										$text = htmlspecialchars(strip_tags(trim($_POST['text'])));
										if(User::a()->isBan === true)$error[] = "Забаненные игроки не могу писать на форуме!";
										if(empty($text) || mb_strlen($text,'UTF-8')<5)$error[] = "Короткое сообщение!";	
										if(mb_strlen($text,'UTF-8')>2000)$error[] = "Слишком длинное сообщение!Максимально разрешено использовать не более 2000 символов";
										if($data['topic']['closed']!=0)$error[] = "Топик закрыт";		
												if(count($error)<1){	
													$result = $Forum->addMessage($data['topic']['forum'],$data['topic']['id'],User::a()->user['id'],$text);
													header("Location:/Forum/ShowTopics/".$data['topic']['forum']."/Topic/".$data['topic']['id']."/?page=".Setting::a()->getPage($result,10));
													die();					
													}
												}
										Template::a()->setTitle($data['topic']['name']);
										Template::a()->set('Forum',$Forum);
										Template::a()->set('data',$data);
										Template::a()->set('error',$error);
										Template::a()->display('forum/topic');		
										break;
										default:
										break;
										}
									}



				
					Template::a()->setTitle($data['forum']['name']);
					Template::a()->set('Forum',$Forum);
					Template::a()->set('data',$data);
					Template::a()->display('forum/topics');	
					break;

					default:
							header("Location:/Forum/");
							die();
							break;
					}
				}

Template::a()->setTitle('Форум');
Template::a()->set('Forum',$Forum);
Template::a()->set('data',$Forum->getForums());
Template::a()->display('forum/index');
?>